<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="108px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="merchantId" label="商家ID">
                <el-input v-model="formData.merchantId"></el-input>
            </el-form-item>
            <el-form-item prop="action" label="位置">
                <el-select v-model="formData.action">
                    <el-option v-for="item in actionOption" :label="item.label"
                    :value="item.value" :key="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="startDateTime" label="推广开始时间">
                <el-date-picker
                        v-model="formData.startDateTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item prop="endDateTime" label="推广结束时间">
                <el-date-picker
                        v-model="formData.endDateTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择日期时间">
                </el-date-picker>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'PromoteEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('promote/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {},
                rules: {},
                actionOption: [
                    {"label": "主推广位", "value": 1},
                    {"label": "副推广位", "value": 2}]
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/promote/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/promote/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
